import java.sql.*;
import java.util.Properties;

/** JDBC Driver documentation can be fount at:
 *  jdbc.postgresql.org/documentation/92/index.html **/

public class DBConnection {
	
	public java.sql.Connection conn;
	public java.sql.PreparedStatement st;
	public java.sql.ResultSet rs;

	public static void main(String[] args){
		
		String hostname  = "";
		String DBname    = "";
		String username  = "";
		String password  = "";	
		
		DBConnection newConn = new DBConnection();
		
		try {
			newConn.loadDriver();
		} 
		catch (ClassNotFoundException e) {			
			e.printStackTrace();
		}

		try {
			newConn.connectToDatabase(hostname, DBname, username, password);
		} 
		catch (SQLException e) {
			e.printStackTrace();
		}
		
		try {
			newConn.executeSelect("JR", "Computer Science");
		} 
		catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public DBConnection() {
		
		this.conn = null;
		this.st = null;
		this.rs = null;	
	}
	
	public void loadDriver() throws ClassNotFoundException {
		
		String driver = "org.postgresql.Driver";
		Class.forName(driver);
		println("JDBC driver loaded!");
		
	}
	
	public void connectToDatabase(String hostname, String DB, String username, String password) throws SQLException {
		
		println("Establishing a connection to DB " + DB +". ..");
		
		String url = "jdbc:postgresql://" + hostname + "/" + DB;
		Properties props = new Properties();
		props.setProperty("user", user);
		props.setProperty("password", password);
		conn = DriverManager.getConnection(url, props);
		
		println("Connection established!");
	}
	
	public void executeSelect(String standing, String major) throws SQLException {
		
			String query = "select * from student where standing = ? and major = ?";
			
			st = conn.prepareStatement(query);
			st.setString(1, standing);
			st.setString(2, major);
			rs = st.executeQuery();
			
			println("returning result set");
			return rs;
			
			ResultSetMetaData md = rs.getMetaData();
			int numCols = md.getColumnCount();
		
			while(rs.next()) 
			{
				for(int i = 1; i <= numCols; i++)
				{
					print(rs.getObject(i));
				
					if(i != numCols)
						print(" | ");
				}
				println();
			}
	}
	
	public void clean() throws SQLException {
		
		st.close();
		rs.close();
	}
	
	public static void println(Object msg)
	{
		System.out.println(msg.toString());
	}
	
	public static void print(Object msg)
	{
		System.out.print(msg.toString());
	}
}
